﻿
function setKeyframeColor(){
    // get color index and name from prefs
    if(app.preferences.havePref("keyframe buttons", "keyframe button # 1") ){
            var labelIndexNumber = app.preferences.getPrefAsFloat("keyframe buttons", "keyframe button # 1"); 
            var colorname = app.preferences.getPrefAsString("Label Preference Text Section 5", "Label Text ID 2 # "+ labelIndexNumber, PREFType.PREF_Type_MACHINE_INDEPENDENT);;
        }else{
            var labelIndexNumber = 0; var colorname = "uncolored";
    }
    // get selected keyframes color indexes and color names
    var myKeys = app.project.activeItem.selectedProperties;
    var numberOfLayers = myKeys.length;    

app.beginUndoGroup("Keyframe Label "+ colorname);
    for(var ilayer = 0; ilayer < numberOfLayers;ilayer=ilayer+1){
      if(myKeys[ilayer].propertyType == 6213){
          // empty effects group
        } else {
        var groupNum = ilayer;
        var mySelectedKeys = myKeys[groupNum].selectedKeys;
        var nameDepth = myKeys[groupNum].propertyDepth;
        var groupName = myKeys[groupNum].parentProperty.name;
        var valueName = myKeys[groupNum].matchName;
        var numberOfKeys = myKeys[groupNum].selectedKeys.length;
        for(var ikey = 0; ikey < numberOfKeys ;ikey++){
            var prop = myKeys[groupNum].parentProperty;
            var keyframeFullName = "property(\""+ valueName  +"\")";
            var keyIndex = mySelectedKeys[ikey];
            for(var iname = 0; iname < nameDepth;iname++){
                var namePart = prop.name;
                if(iname+1 == nameDepth){
                    keyframeFullName = "layer(\""+ ( namePart ) +"\")." + keyframeFullName ;
                    } else {
                    keyframeFullName = "property(\""+ ( namePart ) +"\")." + keyframeFullName ;
                }
                prop = prop.parentProperty;
            }
            eval( String( "app.project.activeItem."+ keyframeFullName + ".setLabelAtKey("+keyIndex+", "+ labelIndexNumber +");") );
        }
      }
    }
app.endUndoGroup();
if(app.activeViewer!=null){app.activeViewer.setActive();}
}

setKeyframeColor();