﻿
function keyframeColors(){
    // get selected keyframes color indexes and color names
    var myColorTest = app.project.activeItem.selectedProperties;
    var myColors = [];
    var myLabels = [];
    var numberOfLayers = myColorTest.length;
    
    for(var ilayer = 0; ilayer < numberOfLayers;ilayer=ilayer+1){
        if(myColorTest[ilayer].propertyType == 6213){
          // empty effects group
        } else {
            var groupNum = ilayer;
            var mySelectedKeys = myColorTest[groupNum].selectedKeys;
            var numberOfKeys = myColorTest[groupNum].selectedKeys.length;
                for(var ikey = 0; ikey < numberOfKeys ;ikey++){
                    var keyColor = myColorTest[groupNum].keyLabel(mySelectedKeys[ikey]);
                    if(keyColor == 0){
                        var labelColor = "Uncolored";
                        }else{
                        var labelColor = app.preferences.getPrefAsString("Label Preference Text Section 5", "Label Text ID 2 # "+keyColor, PREFType.PREF_Type_MACHINE_INDEPENDENT);
                    }
                    myColors.push(keyColor);
                    myLabels.push(labelColor);
                }
        }
    }
    return [myColors, myLabels];
}

function setKeyframeColor(labelsArray){
    var keyframeIndex = 0;
    // get selected keyframes color indexes and color names
    var myKeys = app.project.activeItem.selectedProperties;
    var numberOfLayers = myKeys.length;    

app.beginUndoGroup("Keyframe Label change colors");
    var keyframeIndex = 0;
    for(var ilayer = 0; ilayer < numberOfLayers;ilayer=ilayer+1){
      if(myKeys[ilayer].propertyType == 6213){
          // empty effects group
        } else {
        var groupNum = ilayer;
        var mySelectedKeys = myKeys[groupNum].selectedKeys;
        var nameDepth = myKeys[groupNum].propertyDepth;
        var groupName = myKeys[groupNum].parentProperty.name;
        var valueName = myKeys[groupNum].matchName;
        var numberOfKeys = myKeys[groupNum].selectedKeys.length;
        for(var ikey = 0; ikey < numberOfKeys ;ikey++){
            var prop = myKeys[groupNum].parentProperty;
            var keyframeFullName = "property(\""+ valueName  +"\")";
            var keyIndex = mySelectedKeys[ikey];
            for(var iname = 0; iname < nameDepth;iname++){
                var namePart = prop.name;
                if(iname+1 == nameDepth){
                    keyframeFullName = "layer(\""+ ( namePart ) +"\")." + keyframeFullName ;
                    } else {
                    keyframeFullName = "property(\""+ ( namePart ) +"\")." + keyframeFullName ;
                }
                prop = prop.parentProperty;
            }
            eval( String( "app.project.activeItem."+ keyframeFullName + ".setLabelAtKey("+keyIndex+", "+ labelsArray[keyframeIndex] +");") );
            keyframeIndex = keyframeIndex +1;
        }
      }
    }
app.endUndoGroup();
if(app.activeViewer!=null){app.activeViewer.setActive();}
}

var labelsArray = keyframeColors()[0];
var labelsArrayLength = labelsArray.length;

var changedLabelsArray = [];
for(var i = 0; i<labelsArrayLength;i++){
    var next = (labelsArray[i] + 1)%17;
    changedLabelsArray.push( next );
}

setKeyframeColor(changedLabelsArray);